/*
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.ai.generativelanguage.v1.stub;

import com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest;
import com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse;
import com.google.ai.generativelanguage.v1.CountTokensRequest;
import com.google.ai.generativelanguage.v1.CountTokensResponse;
import com.google.ai.generativelanguage.v1.EmbedContentRequest;
import com.google.ai.generativelanguage.v1.EmbedContentResponse;
import com.google.ai.generativelanguage.v1.GenerateContentRequest;
import com.google.ai.generativelanguage.v1.GenerateContentResponse;
import com.google.api.gax.core.BackgroundResource;
import com.google.api.gax.rpc.ServerStreamingCallable;
import com.google.api.gax.rpc.UnaryCallable;
import javax.annotation.Generated;

// AUTO-GENERATED DOCUMENTATION AND CLASS.
/**
 * Base stub class for the GenerativeService service API.
 *
 * <p>This class is for advanced usage and reflects the underlying API directly.
 */
@Generated("by gapic-generator-java")
public abstract class GenerativeServiceStub implements BackgroundResource {

  public UnaryCallable<GenerateContentRequest, GenerateContentResponse> generateContentCallable() {
    throw new UnsupportedOperationException("Not implemented: generateContentCallable()");
  }

  public ServerStreamingCallable<GenerateContentRequest, GenerateContentResponse>
      streamGenerateContentCallable() {
    throw new UnsupportedOperationException("Not implemented: streamGenerateContentCallable()");
  }

  public UnaryCallable<EmbedContentRequest, EmbedContentResponse> embedContentCallable() {
    throw new UnsupportedOperationException("Not implemented: embedContentCallable()");
  }

  public UnaryCallable<BatchEmbedContentsRequest, BatchEmbedContentsResponse>
      batchEmbedContentsCallable() {
    throw new UnsupportedOperationException("Not implemented: batchEmbedContentsCallable()");
  }

  public UnaryCallable<CountTokensRequest, CountTokensResponse> countTokensCallable() {
    throw new UnsupportedOperationException("Not implemented: countTokensCallable()");
  }

  @Override
  public abstract void close();
}
