package com.google.ai.generativelanguage.v1;

import static io.grpc.MethodDescriptor.generateFullMethodName;

/**
 * <pre>
 * API for using Large Models that generate multimodal content and have
 * additional capabilities beyond text generation.
 * </pre>
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler",
    comments = "Source: google/ai/generativelanguage/v1/generative_service.proto")
@io.grpc.stub.annotations.GrpcGenerated
public final class GenerativeServiceGrpc {

  private GenerativeServiceGrpc() {}

  public static final java.lang.String SERVICE_NAME = "google.ai.generativelanguage.v1.GenerativeService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest,
      com.google.ai.generativelanguage.v1.GenerateContentResponse> getGenerateContentMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GenerateContent",
      requestType = com.google.ai.generativelanguage.v1.GenerateContentRequest.class,
      responseType = com.google.ai.generativelanguage.v1.GenerateContentResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest,
      com.google.ai.generativelanguage.v1.GenerateContentResponse> getGenerateContentMethod() {
    io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest, com.google.ai.generativelanguage.v1.GenerateContentResponse> getGenerateContentMethod;
    if ((getGenerateContentMethod = GenerativeServiceGrpc.getGenerateContentMethod) == null) {
      synchronized (GenerativeServiceGrpc.class) {
        if ((getGenerateContentMethod = GenerativeServiceGrpc.getGenerateContentMethod) == null) {
          GenerativeServiceGrpc.getGenerateContentMethod = getGenerateContentMethod =
              io.grpc.MethodDescriptor.<com.google.ai.generativelanguage.v1.GenerateContentRequest, com.google.ai.generativelanguage.v1.GenerateContentResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GenerateContent"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.GenerateContentRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.GenerateContentResponse.getDefaultInstance()))
              .setSchemaDescriptor(new GenerativeServiceMethodDescriptorSupplier("GenerateContent"))
              .build();
        }
      }
    }
    return getGenerateContentMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest,
      com.google.ai.generativelanguage.v1.GenerateContentResponse> getStreamGenerateContentMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StreamGenerateContent",
      requestType = com.google.ai.generativelanguage.v1.GenerateContentRequest.class,
      responseType = com.google.ai.generativelanguage.v1.GenerateContentResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
  public static io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest,
      com.google.ai.generativelanguage.v1.GenerateContentResponse> getStreamGenerateContentMethod() {
    io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.GenerateContentRequest, com.google.ai.generativelanguage.v1.GenerateContentResponse> getStreamGenerateContentMethod;
    if ((getStreamGenerateContentMethod = GenerativeServiceGrpc.getStreamGenerateContentMethod) == null) {
      synchronized (GenerativeServiceGrpc.class) {
        if ((getStreamGenerateContentMethod = GenerativeServiceGrpc.getStreamGenerateContentMethod) == null) {
          GenerativeServiceGrpc.getStreamGenerateContentMethod = getStreamGenerateContentMethod =
              io.grpc.MethodDescriptor.<com.google.ai.generativelanguage.v1.GenerateContentRequest, com.google.ai.generativelanguage.v1.GenerateContentResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StreamGenerateContent"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.GenerateContentRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.GenerateContentResponse.getDefaultInstance()))
              .setSchemaDescriptor(new GenerativeServiceMethodDescriptorSupplier("StreamGenerateContent"))
              .build();
        }
      }
    }
    return getStreamGenerateContentMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.EmbedContentRequest,
      com.google.ai.generativelanguage.v1.EmbedContentResponse> getEmbedContentMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "EmbedContent",
      requestType = com.google.ai.generativelanguage.v1.EmbedContentRequest.class,
      responseType = com.google.ai.generativelanguage.v1.EmbedContentResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.EmbedContentRequest,
      com.google.ai.generativelanguage.v1.EmbedContentResponse> getEmbedContentMethod() {
    io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.EmbedContentRequest, com.google.ai.generativelanguage.v1.EmbedContentResponse> getEmbedContentMethod;
    if ((getEmbedContentMethod = GenerativeServiceGrpc.getEmbedContentMethod) == null) {
      synchronized (GenerativeServiceGrpc.class) {
        if ((getEmbedContentMethod = GenerativeServiceGrpc.getEmbedContentMethod) == null) {
          GenerativeServiceGrpc.getEmbedContentMethod = getEmbedContentMethod =
              io.grpc.MethodDescriptor.<com.google.ai.generativelanguage.v1.EmbedContentRequest, com.google.ai.generativelanguage.v1.EmbedContentResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "EmbedContent"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.EmbedContentRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.EmbedContentResponse.getDefaultInstance()))
              .setSchemaDescriptor(new GenerativeServiceMethodDescriptorSupplier("EmbedContent"))
              .build();
        }
      }
    }
    return getEmbedContentMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest,
      com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> getBatchEmbedContentsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "BatchEmbedContents",
      requestType = com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest.class,
      responseType = com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest,
      com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> getBatchEmbedContentsMethod() {
    io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest, com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> getBatchEmbedContentsMethod;
    if ((getBatchEmbedContentsMethod = GenerativeServiceGrpc.getBatchEmbedContentsMethod) == null) {
      synchronized (GenerativeServiceGrpc.class) {
        if ((getBatchEmbedContentsMethod = GenerativeServiceGrpc.getBatchEmbedContentsMethod) == null) {
          GenerativeServiceGrpc.getBatchEmbedContentsMethod = getBatchEmbedContentsMethod =
              io.grpc.MethodDescriptor.<com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest, com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "BatchEmbedContents"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse.getDefaultInstance()))
              .setSchemaDescriptor(new GenerativeServiceMethodDescriptorSupplier("BatchEmbedContents"))
              .build();
        }
      }
    }
    return getBatchEmbedContentsMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.CountTokensRequest,
      com.google.ai.generativelanguage.v1.CountTokensResponse> getCountTokensMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CountTokens",
      requestType = com.google.ai.generativelanguage.v1.CountTokensRequest.class,
      responseType = com.google.ai.generativelanguage.v1.CountTokensResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.CountTokensRequest,
      com.google.ai.generativelanguage.v1.CountTokensResponse> getCountTokensMethod() {
    io.grpc.MethodDescriptor<com.google.ai.generativelanguage.v1.CountTokensRequest, com.google.ai.generativelanguage.v1.CountTokensResponse> getCountTokensMethod;
    if ((getCountTokensMethod = GenerativeServiceGrpc.getCountTokensMethod) == null) {
      synchronized (GenerativeServiceGrpc.class) {
        if ((getCountTokensMethod = GenerativeServiceGrpc.getCountTokensMethod) == null) {
          GenerativeServiceGrpc.getCountTokensMethod = getCountTokensMethod =
              io.grpc.MethodDescriptor.<com.google.ai.generativelanguage.v1.CountTokensRequest, com.google.ai.generativelanguage.v1.CountTokensResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CountTokens"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.CountTokensRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.ai.generativelanguage.v1.CountTokensResponse.getDefaultInstance()))
              .setSchemaDescriptor(new GenerativeServiceMethodDescriptorSupplier("CountTokens"))
              .build();
        }
      }
    }
    return getCountTokensMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static GenerativeServiceStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceStub>() {
        @java.lang.Override
        public GenerativeServiceStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new GenerativeServiceStub(channel, callOptions);
        }
      };
    return GenerativeServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static GenerativeServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceBlockingStub>() {
        @java.lang.Override
        public GenerativeServiceBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new GenerativeServiceBlockingStub(channel, callOptions);
        }
      };
    return GenerativeServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static GenerativeServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<GenerativeServiceFutureStub>() {
        @java.lang.Override
        public GenerativeServiceFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new GenerativeServiceFutureStub(channel, callOptions);
        }
      };
    return GenerativeServiceFutureStub.newStub(factory, channel);
  }

  /**
   * <pre>
   * API for using Large Models that generate multimodal content and have
   * additional capabilities beyond text generation.
   * </pre>
   */
  public interface AsyncService {

    /**
     * <pre>
     * Generates a response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    default void generateContent(com.google.ai.generativelanguage.v1.GenerateContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGenerateContentMethod(), responseObserver);
    }

    /**
     * <pre>
     * Generates a streamed response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    default void streamGenerateContent(com.google.ai.generativelanguage.v1.GenerateContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStreamGenerateContentMethod(), responseObserver);
    }

    /**
     * <pre>
     * Generates an embedding from the model given an input `Content`.
     * </pre>
     */
    default void embedContent(com.google.ai.generativelanguage.v1.EmbedContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.EmbedContentResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getEmbedContentMethod(), responseObserver);
    }

    /**
     * <pre>
     * Generates multiple embeddings from the model given input text in a
     * synchronous call.
     * </pre>
     */
    default void batchEmbedContents(com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getBatchEmbedContentsMethod(), responseObserver);
    }

    /**
     * <pre>
     * Runs a model's tokenizer on input content and returns the token count.
     * </pre>
     */
    default void countTokens(com.google.ai.generativelanguage.v1.CountTokensRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.CountTokensResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getCountTokensMethod(), responseObserver);
    }
  }

  /**
   * Base class for the server implementation of the service GenerativeService.
   * <pre>
   * API for using Large Models that generate multimodal content and have
   * additional capabilities beyond text generation.
   * </pre>
   */
  public static abstract class GenerativeServiceImplBase
      implements io.grpc.BindableService, AsyncService {

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return GenerativeServiceGrpc.bindService(this);
    }
  }

  /**
   * A stub to allow clients to do asynchronous rpc calls to service GenerativeService.
   * <pre>
   * API for using Large Models that generate multimodal content and have
   * additional capabilities beyond text generation.
   * </pre>
   */
  public static final class GenerativeServiceStub
      extends io.grpc.stub.AbstractAsyncStub<GenerativeServiceStub> {
    private GenerativeServiceStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected GenerativeServiceStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new GenerativeServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * Generates a response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    public void generateContent(com.google.ai.generativelanguage.v1.GenerateContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGenerateContentMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Generates a streamed response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    public void streamGenerateContent(com.google.ai.generativelanguage.v1.GenerateContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncServerStreamingCall(
          getChannel().newCall(getStreamGenerateContentMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Generates an embedding from the model given an input `Content`.
     * </pre>
     */
    public void embedContent(com.google.ai.generativelanguage.v1.EmbedContentRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.EmbedContentResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getEmbedContentMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Generates multiple embeddings from the model given input text in a
     * synchronous call.
     * </pre>
     */
    public void batchEmbedContents(com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getBatchEmbedContentsMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Runs a model's tokenizer on input content and returns the token count.
     * </pre>
     */
    public void countTokens(com.google.ai.generativelanguage.v1.CountTokensRequest request,
        io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.CountTokensResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getCountTokensMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   * A stub to allow clients to do synchronous rpc calls to service GenerativeService.
   * <pre>
   * API for using Large Models that generate multimodal content and have
   * additional capabilities beyond text generation.
   * </pre>
   */
  public static final class GenerativeServiceBlockingStub
      extends io.grpc.stub.AbstractBlockingStub<GenerativeServiceBlockingStub> {
    private GenerativeServiceBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected GenerativeServiceBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new GenerativeServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * Generates a response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    public com.google.ai.generativelanguage.v1.GenerateContentResponse generateContent(com.google.ai.generativelanguage.v1.GenerateContentRequest request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGenerateContentMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Generates a streamed response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    public java.util.Iterator<com.google.ai.generativelanguage.v1.GenerateContentResponse> streamGenerateContent(
        com.google.ai.generativelanguage.v1.GenerateContentRequest request) {
      return io.grpc.stub.ClientCalls.blockingServerStreamingCall(
          getChannel(), getStreamGenerateContentMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Generates an embedding from the model given an input `Content`.
     * </pre>
     */
    public com.google.ai.generativelanguage.v1.EmbedContentResponse embedContent(com.google.ai.generativelanguage.v1.EmbedContentRequest request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getEmbedContentMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Generates multiple embeddings from the model given input text in a
     * synchronous call.
     * </pre>
     */
    public com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse batchEmbedContents(com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getBatchEmbedContentsMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Runs a model's tokenizer on input content and returns the token count.
     * </pre>
     */
    public com.google.ai.generativelanguage.v1.CountTokensResponse countTokens(com.google.ai.generativelanguage.v1.CountTokensRequest request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getCountTokensMethod(), getCallOptions(), request);
    }
  }

  /**
   * A stub to allow clients to do ListenableFuture-style rpc calls to service GenerativeService.
   * <pre>
   * API for using Large Models that generate multimodal content and have
   * additional capabilities beyond text generation.
   * </pre>
   */
  public static final class GenerativeServiceFutureStub
      extends io.grpc.stub.AbstractFutureStub<GenerativeServiceFutureStub> {
    private GenerativeServiceFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected GenerativeServiceFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new GenerativeServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * Generates a response from the model given an input
     * `GenerateContentRequest`.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.ai.generativelanguage.v1.GenerateContentResponse> generateContent(
        com.google.ai.generativelanguage.v1.GenerateContentRequest request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGenerateContentMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Generates an embedding from the model given an input `Content`.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.ai.generativelanguage.v1.EmbedContentResponse> embedContent(
        com.google.ai.generativelanguage.v1.EmbedContentRequest request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getEmbedContentMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Generates multiple embeddings from the model given input text in a
     * synchronous call.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse> batchEmbedContents(
        com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getBatchEmbedContentsMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Runs a model's tokenizer on input content and returns the token count.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.ai.generativelanguage.v1.CountTokensResponse> countTokens(
        com.google.ai.generativelanguage.v1.CountTokensRequest request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getCountTokensMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GENERATE_CONTENT = 0;
  private static final int METHODID_STREAM_GENERATE_CONTENT = 1;
  private static final int METHODID_EMBED_CONTENT = 2;
  private static final int METHODID_BATCH_EMBED_CONTENTS = 3;
  private static final int METHODID_COUNT_TOKENS = 4;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final AsyncService serviceImpl;
    private final int methodId;

    MethodHandlers(AsyncService serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GENERATE_CONTENT:
          serviceImpl.generateContent((com.google.ai.generativelanguage.v1.GenerateContentRequest) request,
              (io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse>) responseObserver);
          break;
        case METHODID_STREAM_GENERATE_CONTENT:
          serviceImpl.streamGenerateContent((com.google.ai.generativelanguage.v1.GenerateContentRequest) request,
              (io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.GenerateContentResponse>) responseObserver);
          break;
        case METHODID_EMBED_CONTENT:
          serviceImpl.embedContent((com.google.ai.generativelanguage.v1.EmbedContentRequest) request,
              (io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.EmbedContentResponse>) responseObserver);
          break;
        case METHODID_BATCH_EMBED_CONTENTS:
          serviceImpl.batchEmbedContents((com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse>) responseObserver);
          break;
        case METHODID_COUNT_TOKENS:
          serviceImpl.countTokens((com.google.ai.generativelanguage.v1.CountTokensRequest) request,
              (io.grpc.stub.StreamObserver<com.google.ai.generativelanguage.v1.CountTokensResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  public static final io.grpc.ServerServiceDefinition bindService(AsyncService service) {
    return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
        .addMethod(
          getGenerateContentMethod(),
          io.grpc.stub.ServerCalls.asyncUnaryCall(
            new MethodHandlers<
              com.google.ai.generativelanguage.v1.GenerateContentRequest,
              com.google.ai.generativelanguage.v1.GenerateContentResponse>(
                service, METHODID_GENERATE_CONTENT)))
        .addMethod(
          getStreamGenerateContentMethod(),
          io.grpc.stub.ServerCalls.asyncServerStreamingCall(
            new MethodHandlers<
              com.google.ai.generativelanguage.v1.GenerateContentRequest,
              com.google.ai.generativelanguage.v1.GenerateContentResponse>(
                service, METHODID_STREAM_GENERATE_CONTENT)))
        .addMethod(
          getEmbedContentMethod(),
          io.grpc.stub.ServerCalls.asyncUnaryCall(
            new MethodHandlers<
              com.google.ai.generativelanguage.v1.EmbedContentRequest,
              com.google.ai.generativelanguage.v1.EmbedContentResponse>(
                service, METHODID_EMBED_CONTENT)))
        .addMethod(
          getBatchEmbedContentsMethod(),
          io.grpc.stub.ServerCalls.asyncUnaryCall(
            new MethodHandlers<
              com.google.ai.generativelanguage.v1.BatchEmbedContentsRequest,
              com.google.ai.generativelanguage.v1.BatchEmbedContentsResponse>(
                service, METHODID_BATCH_EMBED_CONTENTS)))
        .addMethod(
          getCountTokensMethod(),
          io.grpc.stub.ServerCalls.asyncUnaryCall(
            new MethodHandlers<
              com.google.ai.generativelanguage.v1.CountTokensRequest,
              com.google.ai.generativelanguage.v1.CountTokensResponse>(
                service, METHODID_COUNT_TOKENS)))
        .build();
  }

  private static abstract class GenerativeServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    GenerativeServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("GenerativeService");
    }
  }

  private static final class GenerativeServiceFileDescriptorSupplier
      extends GenerativeServiceBaseDescriptorSupplier {
    GenerativeServiceFileDescriptorSupplier() {}
  }

  private static final class GenerativeServiceMethodDescriptorSupplier
      extends GenerativeServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final java.lang.String methodName;

    GenerativeServiceMethodDescriptorSupplier(java.lang.String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (GenerativeServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new GenerativeServiceFileDescriptorSupplier())
              .addMethod(getGenerateContentMethod())
              .addMethod(getStreamGenerateContentMethod())
              .addMethod(getEmbedContentMethod())
              .addMethod(getBatchEmbedContentsMethod())
              .addMethod(getCountTokensMethod())
              .build();
        }
      }
    }
    return result;
  }
}
