// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/ai/generativelanguage/v1/generative_service.proto

package com.google.ai.generativelanguage.v1;

/**
 * <pre>
 * Response from the model supporting multiple candidates.
 *
 * Note on safety ratings and content filtering. They are reported for both
 * prompt in `GenerateContentResponse.prompt_feedback` and for each candidate
 * in `finish_reason` and in `safety_ratings`. The API contract is that:
 *  - either all requested candidates are returned or no candidates at all
 *  - no candidates are returned only if there was something wrong with the
 *    prompt (see `prompt_feedback`)
 *  - feedback on each candidate is reported on `finish_reason` and
 *    `safety_ratings`.
 * </pre>
 *
 * Protobuf type {@code google.ai.generativelanguage.v1.GenerateContentResponse}
 */
public final class GenerateContentResponse extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:google.ai.generativelanguage.v1.GenerateContentResponse)
    GenerateContentResponseOrBuilder {
private static final long serialVersionUID = 0L;
  // Use GenerateContentResponse.newBuilder() to construct.
  private GenerateContentResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private GenerateContentResponse() {
    candidates_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new GenerateContentResponse();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.ai.generativelanguage.v1.GenerateContentResponse.class, com.google.ai.generativelanguage.v1.GenerateContentResponse.Builder.class);
  }

  public interface PromptFeedbackOrBuilder extends
      // @@protoc_insertion_point(interface_extends:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * Optional. If set, the prompt was blocked and no candidates are returned.
     * Rephrase your prompt.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return The enum numeric value on the wire for blockReason.
     */
    int getBlockReasonValue();
    /**
     * <pre>
     * Optional. If set, the prompt was blocked and no candidates are returned.
     * Rephrase your prompt.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return The blockReason.
     */
    com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason getBlockReason();

    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    java.util.List<com.google.ai.generativelanguage.v1.SafetyRating> 
        getSafetyRatingsList();
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    com.google.ai.generativelanguage.v1.SafetyRating getSafetyRatings(int index);
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    int getSafetyRatingsCount();
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    java.util.List<? extends com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder> 
        getSafetyRatingsOrBuilderList();
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder getSafetyRatingsOrBuilder(
        int index);
  }
  /**
   * <pre>
   * A set of the feedback metadata the prompt specified in
   * `GenerateContentRequest.content`.
   * </pre>
   *
   * Protobuf type {@code google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback}
   */
  public static final class PromptFeedback extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)
      PromptFeedbackOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use PromptFeedback.newBuilder() to construct.
    private PromptFeedback(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private PromptFeedback() {
      blockReason_ = 0;
      safetyRatings_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new PromptFeedback();
    }

    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_PromptFeedback_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_PromptFeedback_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.class, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder.class);
    }

    /**
     * <pre>
     * Specifies what was the reason why prompt was blocked.
     * </pre>
     *
     * Protobuf enum {@code google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason}
     */
    public enum BlockReason
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <pre>
       * Default value. This value is unused.
       * </pre>
       *
       * <code>BLOCK_REASON_UNSPECIFIED = 0;</code>
       */
      BLOCK_REASON_UNSPECIFIED(0),
      /**
       * <pre>
       * Prompt was blocked due to safety reasons. You can inspect
       * `safety_ratings` to understand which safety category blocked it.
       * </pre>
       *
       * <code>SAFETY = 1;</code>
       */
      SAFETY(1),
      /**
       * <pre>
       * Prompt was blocked due to unknown reaasons.
       * </pre>
       *
       * <code>OTHER = 2;</code>
       */
      OTHER(2),
      UNRECOGNIZED(-1),
      ;

      /**
       * <pre>
       * Default value. This value is unused.
       * </pre>
       *
       * <code>BLOCK_REASON_UNSPECIFIED = 0;</code>
       */
      public static final int BLOCK_REASON_UNSPECIFIED_VALUE = 0;
      /**
       * <pre>
       * Prompt was blocked due to safety reasons. You can inspect
       * `safety_ratings` to understand which safety category blocked it.
       * </pre>
       *
       * <code>SAFETY = 1;</code>
       */
      public static final int SAFETY_VALUE = 1;
      /**
       * <pre>
       * Prompt was blocked due to unknown reaasons.
       * </pre>
       *
       * <code>OTHER = 2;</code>
       */
      public static final int OTHER_VALUE = 2;


      public final int getNumber() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalArgumentException(
              "Can't get the number of an unknown enum value.");
        }
        return value;
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static BlockReason valueOf(int value) {
        return forNumber(value);
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       */
      public static BlockReason forNumber(int value) {
        switch (value) {
          case 0: return BLOCK_REASON_UNSPECIFIED;
          case 1: return SAFETY;
          case 2: return OTHER;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<BlockReason>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final com.google.protobuf.Internal.EnumLiteMap<
          BlockReason> internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<BlockReason>() {
              public BlockReason findValueByNumber(int number) {
                return BlockReason.forNumber(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalStateException(
              "Can't get the descriptor of an unrecognized enum value.");
        }
        return getDescriptor().getValues().get(ordinal());
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDescriptor().getEnumTypes().get(0);
      }

      private static final BlockReason[] VALUES = values();

      public static BlockReason valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
          return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private BlockReason(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason)
    }

    public static final int BLOCK_REASON_FIELD_NUMBER = 1;
    private int blockReason_ = 0;
    /**
     * <pre>
     * Optional. If set, the prompt was blocked and no candidates are returned.
     * Rephrase your prompt.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return The enum numeric value on the wire for blockReason.
     */
    @java.lang.Override public int getBlockReasonValue() {
      return blockReason_;
    }
    /**
     * <pre>
     * Optional. If set, the prompt was blocked and no candidates are returned.
     * Rephrase your prompt.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return The blockReason.
     */
    @java.lang.Override public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason getBlockReason() {
      com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason result = com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.forNumber(blockReason_);
      return result == null ? com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.UNRECOGNIZED : result;
    }

    public static final int SAFETY_RATINGS_FIELD_NUMBER = 2;
    @SuppressWarnings("serial")
    private java.util.List<com.google.ai.generativelanguage.v1.SafetyRating> safetyRatings_;
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.ai.generativelanguage.v1.SafetyRating> getSafetyRatingsList() {
      return safetyRatings_;
    }
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder> 
        getSafetyRatingsOrBuilderList() {
      return safetyRatings_;
    }
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    @java.lang.Override
    public int getSafetyRatingsCount() {
      return safetyRatings_.size();
    }
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    @java.lang.Override
    public com.google.ai.generativelanguage.v1.SafetyRating getSafetyRatings(int index) {
      return safetyRatings_.get(index);
    }
    /**
     * <pre>
     * Ratings for safety of the prompt.
     * There is at most one rating per category.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
     */
    @java.lang.Override
    public com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder getSafetyRatingsOrBuilder(
        int index) {
      return safetyRatings_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (blockReason_ != com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.BLOCK_REASON_UNSPECIFIED.getNumber()) {
        output.writeEnum(1, blockReason_);
      }
      for (int i = 0; i < safetyRatings_.size(); i++) {
        output.writeMessage(2, safetyRatings_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (blockReason_ != com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.BLOCK_REASON_UNSPECIFIED.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(1, blockReason_);
      }
      for (int i = 0; i < safetyRatings_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, safetyRatings_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)) {
        return super.equals(obj);
      }
      com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback other = (com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback) obj;

      if (blockReason_ != other.blockReason_) return false;
      if (!getSafetyRatingsList()
          .equals(other.getSafetyRatingsList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + BLOCK_REASON_FIELD_NUMBER;
      hash = (53 * hash) + blockReason_;
      if (getSafetyRatingsCount() > 0) {
        hash = (37 * hash) + SAFETY_RATINGS_FIELD_NUMBER;
        hash = (53 * hash) + getSafetyRatingsList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }

    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A set of the feedback metadata the prompt specified in
     * `GenerateContentRequest.content`.
     * </pre>
     *
     * Protobuf type {@code google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_PromptFeedback_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_PromptFeedback_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.class, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder.class);
      }

      // Construct using com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        blockReason_ = 0;
        if (safetyRatingsBuilder_ == null) {
          safetyRatings_ = java.util.Collections.emptyList();
        } else {
          safetyRatings_ = null;
          safetyRatingsBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_PromptFeedback_descriptor;
      }

      @java.lang.Override
      public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback getDefaultInstanceForType() {
        return com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback build() {
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback buildPartial() {
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback result = new com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback(this);
        buildPartialRepeatedFields(result);
        if (bitField0_ != 0) { buildPartial0(result); }
        onBuilt();
        return result;
      }

      private void buildPartialRepeatedFields(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback result) {
        if (safetyRatingsBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0)) {
            safetyRatings_ = java.util.Collections.unmodifiableList(safetyRatings_);
            bitField0_ = (bitField0_ & ~0x00000002);
          }
          result.safetyRatings_ = safetyRatings_;
        } else {
          result.safetyRatings_ = safetyRatingsBuilder_.build();
        }
      }

      private void buildPartial0(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.blockReason_ = blockReason_;
        }
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback) {
          return mergeFrom((com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback other) {
        if (other == com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance()) return this;
        if (other.blockReason_ != 0) {
          setBlockReasonValue(other.getBlockReasonValue());
        }
        if (safetyRatingsBuilder_ == null) {
          if (!other.safetyRatings_.isEmpty()) {
            if (safetyRatings_.isEmpty()) {
              safetyRatings_ = other.safetyRatings_;
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              ensureSafetyRatingsIsMutable();
              safetyRatings_.addAll(other.safetyRatings_);
            }
            onChanged();
          }
        } else {
          if (!other.safetyRatings_.isEmpty()) {
            if (safetyRatingsBuilder_.isEmpty()) {
              safetyRatingsBuilder_.dispose();
              safetyRatingsBuilder_ = null;
              safetyRatings_ = other.safetyRatings_;
              bitField0_ = (bitField0_ & ~0x00000002);
              safetyRatingsBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getSafetyRatingsFieldBuilder() : null;
            } else {
              safetyRatingsBuilder_.addAllMessages(other.safetyRatings_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                blockReason_ = input.readEnum();
                bitField0_ |= 0x00000001;
                break;
              } // case 8
              case 18: {
                com.google.ai.generativelanguage.v1.SafetyRating m =
                    input.readMessage(
                        com.google.ai.generativelanguage.v1.SafetyRating.parser(),
                        extensionRegistry);
                if (safetyRatingsBuilder_ == null) {
                  ensureSafetyRatingsIsMutable();
                  safetyRatings_.add(m);
                } else {
                  safetyRatingsBuilder_.addMessage(m);
                }
                break;
              } // case 18
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private int blockReason_ = 0;
      /**
       * <pre>
       * Optional. If set, the prompt was blocked and no candidates are returned.
       * Rephrase your prompt.
       * </pre>
       *
       * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
       * @return The enum numeric value on the wire for blockReason.
       */
      @java.lang.Override public int getBlockReasonValue() {
        return blockReason_;
      }
      /**
       * <pre>
       * Optional. If set, the prompt was blocked and no candidates are returned.
       * Rephrase your prompt.
       * </pre>
       *
       * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
       * @param value The enum numeric value on the wire for blockReason to set.
       * @return This builder for chaining.
       */
      public Builder setBlockReasonValue(int value) {
        blockReason_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Optional. If set, the prompt was blocked and no candidates are returned.
       * Rephrase your prompt.
       * </pre>
       *
       * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
       * @return The blockReason.
       */
      @java.lang.Override
      public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason getBlockReason() {
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason result = com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.forNumber(blockReason_);
        return result == null ? com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason.UNRECOGNIZED : result;
      }
      /**
       * <pre>
       * Optional. If set, the prompt was blocked and no candidates are returned.
       * Rephrase your prompt.
       * </pre>
       *
       * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
       * @param value The blockReason to set.
       * @return This builder for chaining.
       */
      public Builder setBlockReason(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000001;
        blockReason_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Optional. If set, the prompt was blocked and no candidates are returned.
       * Rephrase your prompt.
       * </pre>
       *
       * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.BlockReason block_reason = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
       * @return This builder for chaining.
       */
      public Builder clearBlockReason() {
        bitField0_ = (bitField0_ & ~0x00000001);
        blockReason_ = 0;
        onChanged();
        return this;
      }

      private java.util.List<com.google.ai.generativelanguage.v1.SafetyRating> safetyRatings_ =
        java.util.Collections.emptyList();
      private void ensureSafetyRatingsIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          safetyRatings_ = new java.util.ArrayList<com.google.ai.generativelanguage.v1.SafetyRating>(safetyRatings_);
          bitField0_ |= 0x00000002;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.ai.generativelanguage.v1.SafetyRating, com.google.ai.generativelanguage.v1.SafetyRating.Builder, com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder> safetyRatingsBuilder_;

      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public java.util.List<com.google.ai.generativelanguage.v1.SafetyRating> getSafetyRatingsList() {
        if (safetyRatingsBuilder_ == null) {
          return java.util.Collections.unmodifiableList(safetyRatings_);
        } else {
          return safetyRatingsBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public int getSafetyRatingsCount() {
        if (safetyRatingsBuilder_ == null) {
          return safetyRatings_.size();
        } else {
          return safetyRatingsBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public com.google.ai.generativelanguage.v1.SafetyRating getSafetyRatings(int index) {
        if (safetyRatingsBuilder_ == null) {
          return safetyRatings_.get(index);
        } else {
          return safetyRatingsBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder setSafetyRatings(
          int index, com.google.ai.generativelanguage.v1.SafetyRating value) {
        if (safetyRatingsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSafetyRatingsIsMutable();
          safetyRatings_.set(index, value);
          onChanged();
        } else {
          safetyRatingsBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder setSafetyRatings(
          int index, com.google.ai.generativelanguage.v1.SafetyRating.Builder builderForValue) {
        if (safetyRatingsBuilder_ == null) {
          ensureSafetyRatingsIsMutable();
          safetyRatings_.set(index, builderForValue.build());
          onChanged();
        } else {
          safetyRatingsBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder addSafetyRatings(com.google.ai.generativelanguage.v1.SafetyRating value) {
        if (safetyRatingsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSafetyRatingsIsMutable();
          safetyRatings_.add(value);
          onChanged();
        } else {
          safetyRatingsBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder addSafetyRatings(
          int index, com.google.ai.generativelanguage.v1.SafetyRating value) {
        if (safetyRatingsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSafetyRatingsIsMutable();
          safetyRatings_.add(index, value);
          onChanged();
        } else {
          safetyRatingsBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder addSafetyRatings(
          com.google.ai.generativelanguage.v1.SafetyRating.Builder builderForValue) {
        if (safetyRatingsBuilder_ == null) {
          ensureSafetyRatingsIsMutable();
          safetyRatings_.add(builderForValue.build());
          onChanged();
        } else {
          safetyRatingsBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder addSafetyRatings(
          int index, com.google.ai.generativelanguage.v1.SafetyRating.Builder builderForValue) {
        if (safetyRatingsBuilder_ == null) {
          ensureSafetyRatingsIsMutable();
          safetyRatings_.add(index, builderForValue.build());
          onChanged();
        } else {
          safetyRatingsBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder addAllSafetyRatings(
          java.lang.Iterable<? extends com.google.ai.generativelanguage.v1.SafetyRating> values) {
        if (safetyRatingsBuilder_ == null) {
          ensureSafetyRatingsIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, safetyRatings_);
          onChanged();
        } else {
          safetyRatingsBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder clearSafetyRatings() {
        if (safetyRatingsBuilder_ == null) {
          safetyRatings_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
          onChanged();
        } else {
          safetyRatingsBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public Builder removeSafetyRatings(int index) {
        if (safetyRatingsBuilder_ == null) {
          ensureSafetyRatingsIsMutable();
          safetyRatings_.remove(index);
          onChanged();
        } else {
          safetyRatingsBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public com.google.ai.generativelanguage.v1.SafetyRating.Builder getSafetyRatingsBuilder(
          int index) {
        return getSafetyRatingsFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder getSafetyRatingsOrBuilder(
          int index) {
        if (safetyRatingsBuilder_ == null) {
          return safetyRatings_.get(index);  } else {
          return safetyRatingsBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public java.util.List<? extends com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder> 
           getSafetyRatingsOrBuilderList() {
        if (safetyRatingsBuilder_ != null) {
          return safetyRatingsBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(safetyRatings_);
        }
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public com.google.ai.generativelanguage.v1.SafetyRating.Builder addSafetyRatingsBuilder() {
        return getSafetyRatingsFieldBuilder().addBuilder(
            com.google.ai.generativelanguage.v1.SafetyRating.getDefaultInstance());
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public com.google.ai.generativelanguage.v1.SafetyRating.Builder addSafetyRatingsBuilder(
          int index) {
        return getSafetyRatingsFieldBuilder().addBuilder(
            index, com.google.ai.generativelanguage.v1.SafetyRating.getDefaultInstance());
      }
      /**
       * <pre>
       * Ratings for safety of the prompt.
       * There is at most one rating per category.
       * </pre>
       *
       * <code>repeated .google.ai.generativelanguage.v1.SafetyRating safety_ratings = 2;</code>
       */
      public java.util.List<com.google.ai.generativelanguage.v1.SafetyRating.Builder> 
           getSafetyRatingsBuilderList() {
        return getSafetyRatingsFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.ai.generativelanguage.v1.SafetyRating, com.google.ai.generativelanguage.v1.SafetyRating.Builder, com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder> 
          getSafetyRatingsFieldBuilder() {
        if (safetyRatingsBuilder_ == null) {
          safetyRatingsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.ai.generativelanguage.v1.SafetyRating, com.google.ai.generativelanguage.v1.SafetyRating.Builder, com.google.ai.generativelanguage.v1.SafetyRatingOrBuilder>(
                  safetyRatings_,
                  ((bitField0_ & 0x00000002) != 0),
                  getParentForChildren(),
                  isClean());
          safetyRatings_ = null;
        }
        return safetyRatingsBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)
    }

    // @@protoc_insertion_point(class_scope:google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback)
    private static final com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback();
    }

    public static com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<PromptFeedback>
        PARSER = new com.google.protobuf.AbstractParser<PromptFeedback>() {
      @java.lang.Override
      public PromptFeedback parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<PromptFeedback> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<PromptFeedback> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public static final int CANDIDATES_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<com.google.ai.generativelanguage.v1.Candidate> candidates_;
  /**
   * <pre>
   * Candidate responses from the model.
   * </pre>
   *
   * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
   */
  @java.lang.Override
  public java.util.List<com.google.ai.generativelanguage.v1.Candidate> getCandidatesList() {
    return candidates_;
  }
  /**
   * <pre>
   * Candidate responses from the model.
   * </pre>
   *
   * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.ai.generativelanguage.v1.CandidateOrBuilder> 
      getCandidatesOrBuilderList() {
    return candidates_;
  }
  /**
   * <pre>
   * Candidate responses from the model.
   * </pre>
   *
   * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
   */
  @java.lang.Override
  public int getCandidatesCount() {
    return candidates_.size();
  }
  /**
   * <pre>
   * Candidate responses from the model.
   * </pre>
   *
   * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
   */
  @java.lang.Override
  public com.google.ai.generativelanguage.v1.Candidate getCandidates(int index) {
    return candidates_.get(index);
  }
  /**
   * <pre>
   * Candidate responses from the model.
   * </pre>
   *
   * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
   */
  @java.lang.Override
  public com.google.ai.generativelanguage.v1.CandidateOrBuilder getCandidatesOrBuilder(
      int index) {
    return candidates_.get(index);
  }

  public static final int PROMPT_FEEDBACK_FIELD_NUMBER = 2;
  private com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback promptFeedback_;
  /**
   * <pre>
   * Returns the prompt's feedback related to the content filters.
   * </pre>
   *
   * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
   * @return Whether the promptFeedback field is set.
   */
  @java.lang.Override
  public boolean hasPromptFeedback() {
    return promptFeedback_ != null;
  }
  /**
   * <pre>
   * Returns the prompt's feedback related to the content filters.
   * </pre>
   *
   * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
   * @return The promptFeedback.
   */
  @java.lang.Override
  public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback getPromptFeedback() {
    return promptFeedback_ == null ? com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance() : promptFeedback_;
  }
  /**
   * <pre>
   * Returns the prompt's feedback related to the content filters.
   * </pre>
   *
   * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
   */
  @java.lang.Override
  public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder getPromptFeedbackOrBuilder() {
    return promptFeedback_ == null ? com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance() : promptFeedback_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < candidates_.size(); i++) {
      output.writeMessage(1, candidates_.get(i));
    }
    if (promptFeedback_ != null) {
      output.writeMessage(2, getPromptFeedback());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < candidates_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, candidates_.get(i));
    }
    if (promptFeedback_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPromptFeedback());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.google.ai.generativelanguage.v1.GenerateContentResponse)) {
      return super.equals(obj);
    }
    com.google.ai.generativelanguage.v1.GenerateContentResponse other = (com.google.ai.generativelanguage.v1.GenerateContentResponse) obj;

    if (!getCandidatesList()
        .equals(other.getCandidatesList())) return false;
    if (hasPromptFeedback() != other.hasPromptFeedback()) return false;
    if (hasPromptFeedback()) {
      if (!getPromptFeedback()
          .equals(other.getPromptFeedback())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getCandidatesCount() > 0) {
      hash = (37 * hash) + CANDIDATES_FIELD_NUMBER;
      hash = (53 * hash) + getCandidatesList().hashCode();
    }
    if (hasPromptFeedback()) {
      hash = (37 * hash) + PROMPT_FEEDBACK_FIELD_NUMBER;
      hash = (53 * hash) + getPromptFeedback().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }

  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.ai.generativelanguage.v1.GenerateContentResponse parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.google.ai.generativelanguage.v1.GenerateContentResponse prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Response from the model supporting multiple candidates.
   *
   * Note on safety ratings and content filtering. They are reported for both
   * prompt in `GenerateContentResponse.prompt_feedback` and for each candidate
   * in `finish_reason` and in `safety_ratings`. The API contract is that:
   *  - either all requested candidates are returned or no candidates at all
   *  - no candidates are returned only if there was something wrong with the
   *    prompt (see `prompt_feedback`)
   *  - feedback on each candidate is reported on `finish_reason` and
   *    `safety_ratings`.
   * </pre>
   *
   * Protobuf type {@code google.ai.generativelanguage.v1.GenerateContentResponse}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:google.ai.generativelanguage.v1.GenerateContentResponse)
      com.google.ai.generativelanguage.v1.GenerateContentResponseOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.ai.generativelanguage.v1.GenerateContentResponse.class, com.google.ai.generativelanguage.v1.GenerateContentResponse.Builder.class);
    }

    // Construct using com.google.ai.generativelanguage.v1.GenerateContentResponse.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (candidatesBuilder_ == null) {
        candidates_ = java.util.Collections.emptyList();
      } else {
        candidates_ = null;
        candidatesBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      promptFeedback_ = null;
      if (promptFeedbackBuilder_ != null) {
        promptFeedbackBuilder_.dispose();
        promptFeedbackBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.google.ai.generativelanguage.v1.GenerativeServiceProto.internal_static_google_ai_generativelanguage_v1_GenerateContentResponse_descriptor;
    }

    @java.lang.Override
    public com.google.ai.generativelanguage.v1.GenerateContentResponse getDefaultInstanceForType() {
      return com.google.ai.generativelanguage.v1.GenerateContentResponse.getDefaultInstance();
    }

    @java.lang.Override
    public com.google.ai.generativelanguage.v1.GenerateContentResponse build() {
      com.google.ai.generativelanguage.v1.GenerateContentResponse result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.google.ai.generativelanguage.v1.GenerateContentResponse buildPartial() {
      com.google.ai.generativelanguage.v1.GenerateContentResponse result = new com.google.ai.generativelanguage.v1.GenerateContentResponse(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.google.ai.generativelanguage.v1.GenerateContentResponse result) {
      if (candidatesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          candidates_ = java.util.Collections.unmodifiableList(candidates_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.candidates_ = candidates_;
      } else {
        result.candidates_ = candidatesBuilder_.build();
      }
    }

    private void buildPartial0(com.google.ai.generativelanguage.v1.GenerateContentResponse result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.promptFeedback_ = promptFeedbackBuilder_ == null
            ? promptFeedback_
            : promptFeedbackBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.google.ai.generativelanguage.v1.GenerateContentResponse) {
        return mergeFrom((com.google.ai.generativelanguage.v1.GenerateContentResponse)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.google.ai.generativelanguage.v1.GenerateContentResponse other) {
      if (other == com.google.ai.generativelanguage.v1.GenerateContentResponse.getDefaultInstance()) return this;
      if (candidatesBuilder_ == null) {
        if (!other.candidates_.isEmpty()) {
          if (candidates_.isEmpty()) {
            candidates_ = other.candidates_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureCandidatesIsMutable();
            candidates_.addAll(other.candidates_);
          }
          onChanged();
        }
      } else {
        if (!other.candidates_.isEmpty()) {
          if (candidatesBuilder_.isEmpty()) {
            candidatesBuilder_.dispose();
            candidatesBuilder_ = null;
            candidates_ = other.candidates_;
            bitField0_ = (bitField0_ & ~0x00000001);
            candidatesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getCandidatesFieldBuilder() : null;
          } else {
            candidatesBuilder_.addAllMessages(other.candidates_);
          }
        }
      }
      if (other.hasPromptFeedback()) {
        mergePromptFeedback(other.getPromptFeedback());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              com.google.ai.generativelanguage.v1.Candidate m =
                  input.readMessage(
                      com.google.ai.generativelanguage.v1.Candidate.parser(),
                      extensionRegistry);
              if (candidatesBuilder_ == null) {
                ensureCandidatesIsMutable();
                candidates_.add(m);
              } else {
                candidatesBuilder_.addMessage(m);
              }
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPromptFeedbackFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<com.google.ai.generativelanguage.v1.Candidate> candidates_ =
      java.util.Collections.emptyList();
    private void ensureCandidatesIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        candidates_ = new java.util.ArrayList<com.google.ai.generativelanguage.v1.Candidate>(candidates_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.ai.generativelanguage.v1.Candidate, com.google.ai.generativelanguage.v1.Candidate.Builder, com.google.ai.generativelanguage.v1.CandidateOrBuilder> candidatesBuilder_;

    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public java.util.List<com.google.ai.generativelanguage.v1.Candidate> getCandidatesList() {
      if (candidatesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(candidates_);
      } else {
        return candidatesBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public int getCandidatesCount() {
      if (candidatesBuilder_ == null) {
        return candidates_.size();
      } else {
        return candidatesBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public com.google.ai.generativelanguage.v1.Candidate getCandidates(int index) {
      if (candidatesBuilder_ == null) {
        return candidates_.get(index);
      } else {
        return candidatesBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder setCandidates(
        int index, com.google.ai.generativelanguage.v1.Candidate value) {
      if (candidatesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCandidatesIsMutable();
        candidates_.set(index, value);
        onChanged();
      } else {
        candidatesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder setCandidates(
        int index, com.google.ai.generativelanguage.v1.Candidate.Builder builderForValue) {
      if (candidatesBuilder_ == null) {
        ensureCandidatesIsMutable();
        candidates_.set(index, builderForValue.build());
        onChanged();
      } else {
        candidatesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder addCandidates(com.google.ai.generativelanguage.v1.Candidate value) {
      if (candidatesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCandidatesIsMutable();
        candidates_.add(value);
        onChanged();
      } else {
        candidatesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder addCandidates(
        int index, com.google.ai.generativelanguage.v1.Candidate value) {
      if (candidatesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCandidatesIsMutable();
        candidates_.add(index, value);
        onChanged();
      } else {
        candidatesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder addCandidates(
        com.google.ai.generativelanguage.v1.Candidate.Builder builderForValue) {
      if (candidatesBuilder_ == null) {
        ensureCandidatesIsMutable();
        candidates_.add(builderForValue.build());
        onChanged();
      } else {
        candidatesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder addCandidates(
        int index, com.google.ai.generativelanguage.v1.Candidate.Builder builderForValue) {
      if (candidatesBuilder_ == null) {
        ensureCandidatesIsMutable();
        candidates_.add(index, builderForValue.build());
        onChanged();
      } else {
        candidatesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder addAllCandidates(
        java.lang.Iterable<? extends com.google.ai.generativelanguage.v1.Candidate> values) {
      if (candidatesBuilder_ == null) {
        ensureCandidatesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, candidates_);
        onChanged();
      } else {
        candidatesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder clearCandidates() {
      if (candidatesBuilder_ == null) {
        candidates_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        candidatesBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public Builder removeCandidates(int index) {
      if (candidatesBuilder_ == null) {
        ensureCandidatesIsMutable();
        candidates_.remove(index);
        onChanged();
      } else {
        candidatesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public com.google.ai.generativelanguage.v1.Candidate.Builder getCandidatesBuilder(
        int index) {
      return getCandidatesFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public com.google.ai.generativelanguage.v1.CandidateOrBuilder getCandidatesOrBuilder(
        int index) {
      if (candidatesBuilder_ == null) {
        return candidates_.get(index);  } else {
        return candidatesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public java.util.List<? extends com.google.ai.generativelanguage.v1.CandidateOrBuilder> 
         getCandidatesOrBuilderList() {
      if (candidatesBuilder_ != null) {
        return candidatesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(candidates_);
      }
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public com.google.ai.generativelanguage.v1.Candidate.Builder addCandidatesBuilder() {
      return getCandidatesFieldBuilder().addBuilder(
          com.google.ai.generativelanguage.v1.Candidate.getDefaultInstance());
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public com.google.ai.generativelanguage.v1.Candidate.Builder addCandidatesBuilder(
        int index) {
      return getCandidatesFieldBuilder().addBuilder(
          index, com.google.ai.generativelanguage.v1.Candidate.getDefaultInstance());
    }
    /**
     * <pre>
     * Candidate responses from the model.
     * </pre>
     *
     * <code>repeated .google.ai.generativelanguage.v1.Candidate candidates = 1;</code>
     */
    public java.util.List<com.google.ai.generativelanguage.v1.Candidate.Builder> 
         getCandidatesBuilderList() {
      return getCandidatesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.ai.generativelanguage.v1.Candidate, com.google.ai.generativelanguage.v1.Candidate.Builder, com.google.ai.generativelanguage.v1.CandidateOrBuilder> 
        getCandidatesFieldBuilder() {
      if (candidatesBuilder_ == null) {
        candidatesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.ai.generativelanguage.v1.Candidate, com.google.ai.generativelanguage.v1.Candidate.Builder, com.google.ai.generativelanguage.v1.CandidateOrBuilder>(
                candidates_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        candidates_ = null;
      }
      return candidatesBuilder_;
    }

    private com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback promptFeedback_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder> promptFeedbackBuilder_;
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     * @return Whether the promptFeedback field is set.
     */
    public boolean hasPromptFeedback() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     * @return The promptFeedback.
     */
    public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback getPromptFeedback() {
      if (promptFeedbackBuilder_ == null) {
        return promptFeedback_ == null ? com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance() : promptFeedback_;
      } else {
        return promptFeedbackBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public Builder setPromptFeedback(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback value) {
      if (promptFeedbackBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        promptFeedback_ = value;
      } else {
        promptFeedbackBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public Builder setPromptFeedback(
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder builderForValue) {
      if (promptFeedbackBuilder_ == null) {
        promptFeedback_ = builderForValue.build();
      } else {
        promptFeedbackBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public Builder mergePromptFeedback(com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback value) {
      if (promptFeedbackBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          promptFeedback_ != null &&
          promptFeedback_ != com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance()) {
          getPromptFeedbackBuilder().mergeFrom(value);
        } else {
          promptFeedback_ = value;
        }
      } else {
        promptFeedbackBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public Builder clearPromptFeedback() {
      bitField0_ = (bitField0_ & ~0x00000002);
      promptFeedback_ = null;
      if (promptFeedbackBuilder_ != null) {
        promptFeedbackBuilder_.dispose();
        promptFeedbackBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder getPromptFeedbackBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPromptFeedbackFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    public com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder getPromptFeedbackOrBuilder() {
      if (promptFeedbackBuilder_ != null) {
        return promptFeedbackBuilder_.getMessageOrBuilder();
      } else {
        return promptFeedback_ == null ?
            com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.getDefaultInstance() : promptFeedback_;
      }
    }
    /**
     * <pre>
     * Returns the prompt's feedback related to the content filters.
     * </pre>
     *
     * <code>.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback prompt_feedback = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder> 
        getPromptFeedbackFieldBuilder() {
      if (promptFeedbackBuilder_ == null) {
        promptFeedbackBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedback.Builder, com.google.ai.generativelanguage.v1.GenerateContentResponse.PromptFeedbackOrBuilder>(
                getPromptFeedback(),
                getParentForChildren(),
                isClean());
        promptFeedback_ = null;
      }
      return promptFeedbackBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:google.ai.generativelanguage.v1.GenerateContentResponse)
  }

  // @@protoc_insertion_point(class_scope:google.ai.generativelanguage.v1.GenerateContentResponse)
  private static final com.google.ai.generativelanguage.v1.GenerateContentResponse DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.google.ai.generativelanguage.v1.GenerateContentResponse();
  }

  public static com.google.ai.generativelanguage.v1.GenerateContentResponse getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GenerateContentResponse>
      PARSER = new com.google.protobuf.AbstractParser<GenerateContentResponse>() {
    @java.lang.Override
    public GenerateContentResponse parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<GenerateContentResponse> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GenerateContentResponse> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.ai.generativelanguage.v1.GenerateContentResponse getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

