/*
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.ai.generativelanguage.v1.samples;

// [START generativelanguage_v1_generated_GenerativeService_GenerateContent_async]
import com.google.ai.generativelanguage.v1.Content;
import com.google.ai.generativelanguage.v1.GenerateContentRequest;
import com.google.ai.generativelanguage.v1.GenerateContentResponse;
import com.google.ai.generativelanguage.v1.GenerationConfig;
import com.google.ai.generativelanguage.v1.GenerativeServiceClient;
import com.google.ai.generativelanguage.v1.ModelName;
import com.google.ai.generativelanguage.v1.SafetySetting;
import com.google.api.core.ApiFuture;
import java.util.ArrayList;

public class AsyncGenerateContent {

  public static void main(String[] args) throws Exception {
    asyncGenerateContent();
  }

  public static void asyncGenerateContent() throws Exception {
    // This snippet has been automatically generated and should be regarded as a code template only.
    // It will require modifications to work:
    // - It may require correct/in-range values for request initialization.
    // - It may require specifying regional endpoints when creating the service client as shown in
    // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
    try (GenerativeServiceClient generativeServiceClient = GenerativeServiceClient.create()) {
      GenerateContentRequest request =
          GenerateContentRequest.newBuilder()
              .setModel(ModelName.of("[MODEL]").toString())
              .addAllContents(new ArrayList<Content>())
              .addAllSafetySettings(new ArrayList<SafetySetting>())
              .setGenerationConfig(GenerationConfig.newBuilder().build())
              .build();
      ApiFuture<GenerateContentResponse> future =
          generativeServiceClient.generateContentCallable().futureCall(request);
      // Do something.
      GenerateContentResponse response = future.get();
    }
  }
}
// [END generativelanguage_v1_generated_GenerativeService_GenerateContent_async]
